// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.12.4
// source: enrollment/enrollment_svc.proto

package enrollment

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// EnrollmentServiceClient is the client API for EnrollmentService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type EnrollmentServiceClient interface {
	EnrollQuiz(ctx context.Context, in *QuizEnrollments, opts ...grpc.CallOption) (*SetQuizEnrollmentResponse, error)
	TakeQuiz(ctx context.Context, opts ...grpc.CallOption) (EnrollmentService_TakeQuizClient, error)
}

type enrollmentServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewEnrollmentServiceClient(cc grpc.ClientConnInterface) EnrollmentServiceClient {
	return &enrollmentServiceClient{cc}
}

func (c *enrollmentServiceClient) EnrollQuiz(ctx context.Context, in *QuizEnrollments, opts ...grpc.CallOption) (*SetQuizEnrollmentResponse, error) {
	out := new(SetQuizEnrollmentResponse)
	err := c.cc.Invoke(ctx, "/enrollment.EnrollmentService/EnrollQuiz", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *enrollmentServiceClient) TakeQuiz(ctx context.Context, opts ...grpc.CallOption) (EnrollmentService_TakeQuizClient, error) {
	stream, err := c.cc.NewStream(ctx, &EnrollmentService_ServiceDesc.Streams[0], "/enrollment.EnrollmentService/TakeQuiz", opts...)
	if err != nil {
		return nil, err
	}
	x := &enrollmentServiceTakeQuizClient{stream}
	return x, nil
}

type EnrollmentService_TakeQuizClient interface {
	Send(*GetTakeRequest) error
	Recv() (*SetTakeQuizResponse, error)
	grpc.ClientStream
}

type enrollmentServiceTakeQuizClient struct {
	grpc.ClientStream
}

func (x *enrollmentServiceTakeQuizClient) Send(m *GetTakeRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *enrollmentServiceTakeQuizClient) Recv() (*SetTakeQuizResponse, error) {
	m := new(SetTakeQuizResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// EnrollmentServiceServer is the server API for EnrollmentService service.
// All implementations must embed UnimplementedEnrollmentServiceServer
// for forward compatibility
type EnrollmentServiceServer interface {
	EnrollQuiz(context.Context, *QuizEnrollments) (*SetQuizEnrollmentResponse, error)
	TakeQuiz(EnrollmentService_TakeQuizServer) error
	mustEmbedUnimplementedEnrollmentServiceServer()
}

// UnimplementedEnrollmentServiceServer must be embedded to have forward compatible implementations.
type UnimplementedEnrollmentServiceServer struct {
}

func (UnimplementedEnrollmentServiceServer) EnrollQuiz(context.Context, *QuizEnrollments) (*SetQuizEnrollmentResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method EnrollQuiz not implemented")
}
func (UnimplementedEnrollmentServiceServer) TakeQuiz(EnrollmentService_TakeQuizServer) error {
	return status.Errorf(codes.Unimplemented, "method TakeQuiz not implemented")
}
func (UnimplementedEnrollmentServiceServer) mustEmbedUnimplementedEnrollmentServiceServer() {}

// UnsafeEnrollmentServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to EnrollmentServiceServer will
// result in compilation errors.
type UnsafeEnrollmentServiceServer interface {
	mustEmbedUnimplementedEnrollmentServiceServer()
}

func RegisterEnrollmentServiceServer(s grpc.ServiceRegistrar, srv EnrollmentServiceServer) {
	s.RegisterService(&EnrollmentService_ServiceDesc, srv)
}

func _EnrollmentService_EnrollQuiz_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(QuizEnrollments)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EnrollmentServiceServer).EnrollQuiz(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/enrollment.EnrollmentService/EnrollQuiz",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EnrollmentServiceServer).EnrollQuiz(ctx, req.(*QuizEnrollments))
	}
	return interceptor(ctx, in, info, handler)
}

func _EnrollmentService_TakeQuiz_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(EnrollmentServiceServer).TakeQuiz(&enrollmentServiceTakeQuizServer{stream})
}

type EnrollmentService_TakeQuizServer interface {
	Send(*SetTakeQuizResponse) error
	Recv() (*GetTakeRequest, error)
	grpc.ServerStream
}

type enrollmentServiceTakeQuizServer struct {
	grpc.ServerStream
}

func (x *enrollmentServiceTakeQuizServer) Send(m *SetTakeQuizResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *enrollmentServiceTakeQuizServer) Recv() (*GetTakeRequest, error) {
	m := new(GetTakeRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// EnrollmentService_ServiceDesc is the grpc.ServiceDesc for EnrollmentService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var EnrollmentService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "enrollment.EnrollmentService",
	HandlerType: (*EnrollmentServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "EnrollQuiz",
			Handler:    _EnrollmentService_EnrollQuiz_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "TakeQuiz",
			Handler:       _EnrollmentService_TakeQuiz_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "enrollment/enrollment_svc.proto",
}
